\
\ ps/2 mouse interface
\
\ chu 22:08 07.11.2010 last
\ chu 10:13 03.10.2010
\
\ =============================================================
\
  marker -ps/2-
  
  forth only also assembler decimal

  code -rot
	R16 R24 movw,
	R24  Y+ ld,
	R25  Y+ ld,
	R18  Y+ ld,
	R19  Y+ ld,
	 -Y R17 st,
	 -Y R16 st,
	 -Y R19 st,
	 -Y R18 st,
  end-code

  code (portbit#)
	R16 R25 mov,
	    R25 clr,
	-Y  R25 st,
	-Y  R16 st,
  end-code

  : portbit#: create 8 lshift swap $20 - or
	 , 
	does> i@ (portbit#)
	;

\  1 constant ps/2c
\  0 constant ps/2d

  PORTB 1  portbit#:  ps/2_clk
  PORTB 0  portbit#:  ps/2_data
  
  code +ps/2_clk
	ps/2_clk
	over over 1 -
	swap cbi,	\ set input
	swap sbi,	\ and pull-up
  end-code
  
  code +ps/2_data
	ps/2_data
	over over 1 -
	swap cbi,	\ set input
	swap sbi,	\ and pull-up
  end-code
  
  code -ps/2_clk
	ps/2_clk
	over over 1 -
	swap sbi,	\ set output
	swap cbi,	\ and low
  end-code
  
  code -ps/2_data
	ps/2_data
	over over 1 -
	swap sbi,	\ set output
	swap cbi,	\ and low
  end-code
  
  code ?ps/2_clk+  \ begin ps/2_clk  pin_high? until 
       label>
	ps/2_clk  2 - swap sbis,
       <radr rjmp,	
  end-code
  
  code ?ps/2_clk-  \ begin ps/2_clk  pin_low?  until 
       label>
	ps/2_clk  2 - swap sbic,
       <radr rjmp,	
  end-code
  
  code ?ps/2_data- \ begin ps/2_data pin_low?  until 
       label>
	ps/2_data 2 - swap sbic,
       <radr rjmp,
  end-code
  
  code ?ps/2_data+ \ begin ps/2_data pin_high? until 
       label>
	ps/2_data 2 - swap sbis,
       <radr rjmp,
  end-code
  
  code  ps/2_bit	( p c )
	R16   1 ldi,
	R16 R24 and,	\ get current bit 
	R17  Y+ ld,	\ get parity bit
	R17 R16 eor,	\ check parity
	-Y  R17 st,	\ save parity bit
	    R24 lsr,	\ next data bit
	-Y  R25 st,
	-Y  R24 st,
	R24 R16 mov,	\ current data bit
  end-code
  
  code	ps/2_bit@	\ 1 rshift ps/2_data pin@ if $80 or then
	R24 lsr,
  	ps/2_data 2 - swap sbic,
  	R24 $80 ori,
  end-code


  forth only 

  1 constant odd 

  : ps/2! ( c -- )	\ ps/2 write byte

	odd swap ( p c )
	+ps/2_clk
	+ps/2_data 600 delay	\ idle state
	-ps/2_clk  600 delay	\
	-ps/2_data  18 delay	\ start
	+ps/2_clk		\     bit
	
	8 0 do
	   ?ps/2_clk- ( p' c' )
	    ps/2_bit  if
	   +ps/2_data else 
	   -ps/2_data then
	   ?ps/2_clk+
	loop drop ( p )

	\ parity	
	?ps/2_clk- if
	+ps/2_data else 
	-ps/2_data then
	?ps/2_clk+
	
	\ stop bit
	?ps/2_clk-
	+ps/2_data
	?ps/2_clk+
	
	\ ack bit
	?ps/2_clk-
	?ps/2_data-
	?ps/2_clk+
	?ps/2_data+

	-ps/2_clk	\ inhibit transmission
	;


  : ps/2@  ( -- c )	\ ps/2 read mice byte 

	0		\ room for incoming byte
	+ps/2_data
	+ps/2_clk 80 delay	\ idle ~50us ????hz
	?ps/2_clk-		\
	?ps/2_data-		\ start bit		
	?ps/2_clk+		\

	8 0 do
	   ?ps/2_clk-
	    20  delay  ps/2_bit@
	   ?ps/2_clk+
	loop

      \ parity bit
	?ps/2_clk-
	?ps/2_clk+	\ ignored

      \ stop bit
	?ps/2_clk-
	?ps/2_data+
	?ps/2_clk+	 

      \ hold incoming data
	-ps/2_clk
	;

\ =========================================================
\	

  marker -mice-


         $FA constant mice_ack		\ 
         $FF constant mice_reset 	( 1 + 2 )
         $F2 constant mice_id    	( 1 + 1 )
         $F0 constant mice_remote	( 1 )
         $EB constant mice_read  	( 1 + 3 )
	 $E9 constant mice_status	( 1 + 3 )

	 $80 constant y-ovflw
	 $40 constant x-ovflw
	 $20 constant y-sign
	 $10 constant x-sign
	  $4 constant m-btn
	  $2 constant r-btn
	  $1 constant l-btn


\
\ =========================================================
\ mouse test words

  : m!@ ( n c -- )
	ps/2! 0 ?do ps/2@ .x bl emit loop cr ;

  : !m  3 mice_reset m!@ 300 delay 1 mice_remote m!@ 180 delay ;

  : m@  4 mice_read m!@ ;

\
\ =========================================================
\ 

  : mflags    ( ms  f1  f2  )
        -rot  ( f2  ms  f1  )
         over ( f2  ms  f1  ms )
         and  ( f2  ms  sf1 )
        -rot  ( sf1 f2  ms  )
         and  ( sf1 sf2 )
        ;

  : workout   ( mx f1 f2 )
	-rot  ( f2 mx f1 )
	if $100 + then swap
	if negate then ( dx )
	;


  : m?	mice_read ps/2!
	mice_ack  ps/2@ = if

	ps/2@  ps/2@ 	( ms mx )
	over x-ovflw x-sign ( ms mx ms f1 f2 ) 
	mflags workout ( ms dx )

	over ps/2@
	swap y-ovflw y-sign mflags workout rot
	else 0 0 0 ." mice no ack" cr then
	; ( dx dy ms ) 


\
\ =========================================================
\ 